传送门
文章目录
- 题意:
- 思路:
题意:
给你个nnn个点mmm条边的图,可以选择完成以下两个任务中的一个:
(1)(1)(1)找出大小恰好为n\sqrt nn的一个独立集。
(2)(2)(2)找出一个长度≥n\ge \sqrt n≥n的一个环。
n≤1e5,m≤2e5n\le 1e5,m\le 2e5n≤1e5,m≤2e5。
思路:
我们构造出一颗dfs树,这棵树有一个很重要的性质就是所有非树边链接的两个点都是一个树上的点以及这个点的后代。所以我们可与边建树边找环,可以直接用vectorvectorvector存下来这条链上的编号,输出的话倒着输出即可。
如果找不到这样的环,那么每个点的非树边一定不超过limit−2limit-2limit−2个(limit=nlimit=\sqrt nlimit=n),因为如果>limit−2>limit-2>limit−2的话,那么至少存在limit+1limit+1limit+1条非树边,那么一定可形成一个大小≥limit\ge limit≥limit的一个环,所以得证。
既然非树边一定不超过limit−2limit-2limit−2个,那么我们对每个点染色,当选了一个点的时候,那么与它相邻的点就标记为不选,最终一定可选出一个大小正好为n\sqrt nn的独立集。
所以分情况讨论就好啦。
// Problem: F. Ehab's Last Theorem
// Contest: Codeforces - Codeforces Round #628 (Div. 2)
// URL: https://codeforces.com/contest/1325/problem/F
// Memory Limit: 256 MB
// Time Limit: 1000 ms
//
// Powered by CP Editor (https://cpeditor.org)//#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,avx,avx2,popcnt,tune=native")
//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#define X first
#define Y second
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid (tr[u].l+tr[u].r>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;const int N=300010,M=N*4,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;int n,m;
vector<int>v[N],now,ans;
int depth[N],limit;
bool st[N];void dfs(int u) {now.pb(u);depth[u]=now.size();for(auto x:v[u]) {if(!depth[x]) dfs(x);else if(depth[u]-depth[x]>=limit-1) {printf("2\n");printf("%d\n",depth[u]-depth[x]+1);for(int i=1;i<=depth[u]-depth[x]+1;i++) printf("%d ",now.back()),now.pop_back();puts("");exit(0);}}if(!st[u]) {for(auto x:v[u]) st[x]=1;ans.pb(u);}now.pop_back();
}int main()
{
// ios::sync_with_stdio(false);
// cin.tie(0);scanf("%d%d",&n,&m);limit=sqrt(n);limit+=(limit*limit!=n);while(m--) {int a,b; scanf("%d%d",&a,&b);v[a].pb(b); v[b].pb(a);}dfs(1);printf("1\n");for(int i=0;i<ans.size()&&i<limit;i++) printf("%d ",ans[i]);puts("");return 0;
}
/**/